/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: DelayReqRespMaster
	Configuration 	: MasterClock
	Model Element	: OrdinaryClock
//!	Generated Date	: Mon, 28, Jul 2008 
	File Path	: DelayReqRespMaster/MasterClock/PTPDevices/OrdinaryClock.java
*********************************************************************/

package PTPDevices;

//## auto_generated
import java.util.*;
//## link oClockPort 
import PTPEntities.OClockPort;
//## attribute timeSource 
import PTPEnumTypes.TimeSource;
//## attribute observedParentOffsetScaledLogVariance 
import PTPEntities.PTPVariance;
//## attribute clockClass 
import PTPEnumTypes.ClockClass;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## link oClockParentDS 
import PTPDataSets.OClockParentDS;
//## attribute clockAccuracy 
import PTPEnumTypes.ClockAccuracy;
//## link oClockDefaultDS 
import PTPDataSets.OClockDefaultDS;
//## link oClockCurrentDS 
import PTPDataSets.OClockCurrentDS;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## attribute priority1 
import PTPPrimitivityDataTypes.UInteger8;
//## attribute observedParentClockPhaseChangeRate 
import PTPPrimitivityDataTypes.Integer32;
//## attribute numberPorts 
import PTPPrimitivityDataTypes.UInteger16;
//## link oClockTimePropertiesDS 
import PTPDataSets.OClockTimePropertiesDS;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;

//----------------------------------------------------------------------------
// PTPDevices/OrdinaryClock.java                                                                  
//----------------------------------------------------------------------------

//## package PTPDevices 


/**
Attributes of ordinary clock:
a)	priority1
b)	priority2
c)	clockClass
d)   clockAccuracy
e)    timeSource
f)	offsetScaledLogVariance
g)   numberPorts.
*/
//## class OrdinaryClock 
public class OrdinaryClock extends PTPClock {
    
    protected ClockAccuracy clockAccuracy;		//## attribute clockAccuracy 
    
    protected ClockClass clockClass;		//## attribute clockClass 
    
    protected UInteger16 numberPorts;		//## attribute numberPorts 
    
    /**
    This attribute is optional.
    */
    protected Integer32 observedParentClockPhaseChangeRate;		//## attribute observedParentClockPhaseChangeRate 
    
    /**
    This attribute is optional.
    */
    protected PTPVariance observedParentOffsetScaledLogVariance;		//## attribute observedParentOffsetScaledLogVariance 
    
    /**
    The largest possible positive number, FFFF16, for the offsetScaledLogVariance attribute shall indicate that the variance is either too large to be represented, or has not been computed. 
    */
    protected UInteger16 offsetScaledLogVariance;		//## attribute offsetScaledLogVariance 
    
    /**
    The value of priority1 shall be configurable to any value in the range 0 to 255, 
    */
    protected UInteger8 priority1;		//## attribute priority1 
    
    protected UInteger8 priority2;		//## attribute priority2 
    
    protected TimeSource timeSource;		//## attribute timeSource 
    
    protected LocalClock localClock;		//## link localClock 
    
    protected OClockCurrentDS oClockCurrentDS;		//## link oClockCurrentDS 
    
    protected OClockDefaultDS oClockDefaultDS;		//## link oClockDefaultDS 
    
    protected OClockParentDS oClockParentDS;		//## link oClockParentDS 
    
    protected OClockPort oClockPort;		//## link oClockPort 
    
    protected OClockTimePropertiesDS oClockTimePropertiesDS;		//## link oClockTimePropertiesDS 
    
    
    // Constructors
    
    //## operation OrdinaryClock() 
    public  OrdinaryClock() {
        //#[ operation OrdinaryClock() 
        //#]
    }
    //## operation OrdinaryClock(ClockAccuracy,ClockClass,UInteger16,UInteger16,UInteger8,UInteger8,TimeSource) 
    public  OrdinaryClock(final ClockAccuracy clockAccuracy, final ClockClass clockClass, final UInteger16 numberPorts, final UInteger16 offsetScaledLogVariance, final UInteger8 priority1, final UInteger8 priority2, final TimeSource timeSource) {
        //#[ operation OrdinaryClock(ClockAccuracy,ClockClass,UInteger16,UInteger16,UInteger8,UInteger8,TimeSource) 
            this.clockAccuracy=clockAccuracy;		
            //## attribute clockAccuracy 
            
            this.clockClass=clockClass;		
            //## attribute clockClass 
            
            this.numberPorts=numberPorts;		
            //## attribute numberPorts 
            
            
            this.offsetScaledLogVariance=offsetScaledLogVariance;		
            //## attribute offsetScaledLogVariance 
            
           this.priority1=priority1;		
            //## attribute priority1 
            
            this.priority2=priority2;		
            //## attribute priority2 
            
            this.timeSource=timeSource;		
            //## attribute timeSource 
        //#]
    }
    
    //## auto_generated 
    public ClockAccuracy getClockAccuracy() {
        return clockAccuracy;
    }
    
    //## auto_generated 
    public void setClockAccuracy(ClockAccuracy p_clockAccuracy) {
        clockAccuracy = p_clockAccuracy;
    }
    
    //## auto_generated 
    public ClockClass getClockClass() {
        return clockClass;
    }
    
    //## auto_generated 
    public void setClockClass(ClockClass p_clockClass) {
        clockClass = p_clockClass;
    }
    
    //## auto_generated 
    public UInteger16 getNumberPorts() {
        return numberPorts;
    }
    
    //## auto_generated 
    public void setNumberPorts(UInteger16 p_numberPorts) {
        numberPorts = p_numberPorts;
    }
    
    /**
    This attribute is optional.
    */
    //## auto_generated 
    public Integer32 getObservedParentClockPhaseChangeRate() {
        return observedParentClockPhaseChangeRate;
    }
    
    //## auto_generated 
    public void setObservedParentClockPhaseChangeRate(Integer32 p_observedParentClockPhaseChangeRate) {
        observedParentClockPhaseChangeRate = p_observedParentClockPhaseChangeRate;
    }
    
    /**
    This attribute is optional.
    */
    //## auto_generated 
    public PTPVariance getObservedParentOffsetScaledLogVariance() {
        return observedParentOffsetScaledLogVariance;
    }
    
    //## auto_generated 
    public void setObservedParentOffsetScaledLogVariance(PTPVariance p_observedParentOffsetScaledLogVariance) {
        observedParentOffsetScaledLogVariance = p_observedParentOffsetScaledLogVariance;
    }
    
    /**
    The largest possible positive number, FFFF16, for the offsetScaledLogVariance attribute shall indicate that the variance is either too large to be represented, or has not been computed. 
    */
    //## auto_generated 
    public UInteger16 getOffsetScaledLogVariance() {
        return offsetScaledLogVariance;
    }
    
    //## auto_generated 
    public void setOffsetScaledLogVariance(UInteger16 p_offsetScaledLogVariance) {
        offsetScaledLogVariance = p_offsetScaledLogVariance;
    }
    
    /**
    The value of priority1 shall be configurable to any value in the range 0 to 255, 
    */
    //## auto_generated 
    public UInteger8 getPriority1() {
        return priority1;
    }
    
    //## auto_generated 
    public void setPriority1(UInteger8 p_priority1) {
        priority1 = p_priority1;
    }
    
    //## auto_generated 
    public UInteger8 getPriority2() {
        return priority2;
    }
    
    //## auto_generated 
    public void setPriority2(UInteger8 p_priority2) {
        priority2 = p_priority2;
    }
    
    //## auto_generated 
    public TimeSource getTimeSource() {
        return timeSource;
    }
    
    //## auto_generated 
    public void setTimeSource(TimeSource p_timeSource) {
        timeSource = p_timeSource;
    }
    
    //## auto_generated 
    public LocalClock getLocalClock() {
        return localClock;
    }
    
    //## auto_generated 
    public void setLocalClock(LocalClock p_LocalClock) {
        localClock = p_LocalClock;
    }
    
    //## auto_generated 
    public OClockCurrentDS getOClockCurrentDS() {
        return oClockCurrentDS;
    }
    
    //## auto_generated 
    public void setOClockCurrentDS(OClockCurrentDS p_OClockCurrentDS) {
        oClockCurrentDS = p_OClockCurrentDS;
    }
    
    //## auto_generated 
    public OClockDefaultDS getOClockDefaultDS() {
        return oClockDefaultDS;
    }
    
    //## auto_generated 
    public void setOClockDefaultDS(OClockDefaultDS p_OClockDefaultDS) {
        oClockDefaultDS = p_OClockDefaultDS;
    }
    
    //## auto_generated 
    public OClockParentDS getOClockParentDS() {
        return oClockParentDS;
    }
    
    //## auto_generated 
    public void setOClockParentDS(OClockParentDS p_OClockParentDS) {
        oClockParentDS = p_OClockParentDS;
    }
    
    //## auto_generated 
    public OClockPort getOClockPort() {
        return oClockPort;
    }
    
    //## auto_generated 
    public void setOClockPort(OClockPort p_OClockPort) {
        oClockPort = p_OClockPort;
    }
    
    //## auto_generated 
    public OClockTimePropertiesDS getOClockTimePropertiesDS() {
        return oClockTimePropertiesDS;
    }
    
    //## auto_generated 
    public void setOClockTimePropertiesDS(OClockTimePropertiesDS p_OClockTimePropertiesDS) {
        oClockTimePropertiesDS = p_OClockTimePropertiesDS;
    }
    
}
/*********************************************************************
	File Path	: DelayReqRespMaster/MasterClock/PTPDevices/OrdinaryClock.java
*********************************************************************/

