/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: DelayReqRespSlave
	Configuration 	: SlaveClock
	Model Element	: DelayMechanism
//!	Generated Date	: Mon, 28, Jul 2008 
	File Path	: DelayReqRespSlave/SlaveClock/PTPEnumTypes/DelayMechanism.java
*********************************************************************/

package PTPEnumTypes;

//## auto_generated
import java.util.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;

//----------------------------------------------------------------------------
// PTPEnumTypes/DelayMechanism.java                                                                  
//----------------------------------------------------------------------------

//## package PTPEnumTypes 


/**
Delay mechanism enumeration
Delay mechanism	Value (hex)	Specification	
E2E	01	The port is configured to use the delay request-response mechanism	
P2P	02	The port is configured to use the peer delay mechanism	
DISABLED	FE	The port does not implement the delay mechanism, see Note.	
NOTE- This value shall not be set by a clock except when the applicable PTP profile specifies that the clock syntonize only and that neither path delay mechanism is to be used.	
*/
//## class DelayMechanism 
public class DelayMechanism {
    
    protected static short E2E = 0;		//## attribute E2E 
    
    protected static short P2P = 1;		//## attribute P2P 
    
    protected short delayMechanism;		//## attribute delayMechanism 
    
    
    // Constructors
    
    //## operation DelayMechanism() 
    public  DelayMechanism() {
        //#[ operation DelayMechanism() 
         	//portDS.portIdentity
         	//portDS.portState
         	//portDS.logMinDelayReqInterval
         	//portDS.peerMeanPathDelay
         	//portDS.logAnnounceInterval
         	//portDS.announceReceiptTimeout
         	//portDS.logSyncInterval
         	//portDS.delayMechanism
         	//portDS.logMinPdelayReqInterval
         	//portDS.versionNumber.
        
        //#]
    }
    //## operation DelayMechanism(short) 
    public  DelayMechanism(short delayMechanism) {
        //#[ operation DelayMechanism(short) 
        //#]
    }
    
    //## operation GetDelayMechanism() 
    public short GetDelayMechanism() {
        //#[ operation GetDelayMechanism() 
        return this.delayMechanism;
        
        //#]
    }
    
    //## operation SetDelayMechanism(short) 
    public void SetDelayMechanism(short delayMechanism) {
        //#[ operation SetDelayMechanism(short) 
                switch (delayMechanism)
                {
                case 1: //E2E:
                     this.delayMechanism= E2E;
                     break;
                case 2: //P2P:   
                     this.delayMechanism= P2P;
                     break; 
                default :
                     this.delayMechanism= E2E;
                     break;   
                 }
        //#]
    }
    
    //## auto_generated 
    public static short getE2E() {
        return E2E;
    }
    
    //## auto_generated 
    public static void setE2E(short p_E2E) {
        E2E = p_E2E;
    }
    
    //## auto_generated 
    public static short getP2P() {
        return P2P;
    }
    
    //## auto_generated 
    public static void setP2P(short p_P2P) {
        P2P = p_P2P;
    }
    
    //## auto_generated 
    public short getDelayMechanism() {
        return delayMechanism;
    }
    
    //## auto_generated 
    public void setDelayMechanism(short p_delayMechanism) {
        delayMechanism = p_delayMechanism;
    }
    
}
/*********************************************************************
	File Path	: DelayReqRespSlave/SlaveClock/PTPEnumTypes/DelayMechanism.java
*********************************************************************/

