/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: DelayReqRespSlave
	Configuration 	: SlaveClock
	Model Element	: DelayRequestResponseDefaultPTPPprofile
//!	Generated Date	: Mon, 28, Jul 2008 
	File Path	: DelayReqRespSlave/SlaveClock/PTPProfiles/DelayRequestResponseDefaultPTPPprofile.java
*********************************************************************/

package PTPProfiles;

//## auto_generated
import java.util.*;
//## attribute domain 
import PTPEntities.Domain;
//## attribute announceReceiptTimeout 
import PTPEntities.PTPTimeouts;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## attribute pathDelayMeasurementMechanism 
import PTPEnumTypes.DelayMechanism;
//## attribute logAnnounceInterval 
import PTPDerivedDataTypes.TimeInterval;
//## attribute slaveOnly 
import PTPPrimitivityDataTypes._Boolean;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## attribute priority1 
import PTPPrimitivityDataTypes.UInteger8;
//## attribute frequencyAccuracy 
import PTPPrimitivityDataTypes.Integer32;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;

//----------------------------------------------------------------------------
// PTPProfiles/DelayRequestResponseDefaultPTPPprofile.java                                                                  
//----------------------------------------------------------------------------

//## package PTPProfiles 


/**
PTP Profile
Default PTP profile for use with the delay request-response mechanism.
Version 1.0
Profile identifier: 00-1B-19-00-01-00

This profile is specified by the Precise Networked Clock Synchronization Working Group of the IM/ST Committee.
*/
//## class DelayRequestResponseDefaultPTPPprofile 
public class DelayRequestResponseDefaultPTPPprofile extends PTPProfile {
    
    /**
    The default initialization value shall be 3. The configurable range shall be in the range 2 to 10.
    */
    protected static PTPTimeouts announceReceiptTimeout;		//## attribute announceReceiptTimeout 
    
    /**
    The default initialization value shall be 0.
    */
    protected static Domain domain;		//## attribute domain 
    
    protected Integer32 frequencyAccuracy;		//## attribute frequencyAccuracy 
    
    protected Integer32 frequencyAdjustmentRange;		//## attribute frequencyAdjustmentRange 
    
    /**
    The default initialization value shall be 1. The configurable range shall be 0 to 4
    */
    protected static TimeInterval logAnnounceInterval;		//## attribute logAnnounceInterval 
    
    /**
    The default initialization value shall be 0. The configurable range shall be 0 to 5.
    */
    protected static TimeInterval logMinPdelayReqInterval;		//## attribute logMinPdelayReqInterval 
    
    /**
    The default initialization value shall be 0. The configurable range shall be -1 to +1
    */
    protected static TimeInterval logSyncInterval;		//## attribute logSyncInterval 
    
    /**
    The delay request-response mechanism shall be the default path delay measurement mechanism. The peer delay mechanism may also be implemented. 
    
    The best master clock algorithm shall be the algorithm specified by  9.3.2.
    
    Boundary clocks should be used between links that use different path delay mechanisms.
    
    */
    protected DelayMechanism pathDelayMeasurementMechanism;		//## attribute pathDelayMeasurementMechanism 
    
    /**
    The default initialization value shall be 0. 
    */
    protected static Domain primaryDomain;		//## attribute primaryDomain 
    
    /**
    default initialization value shall be 128.
    */
    protected static UInteger8 priority1;		//## attribute priority1 
    
    /**
    The default initialization value shall be 128. 
    */
    protected static UInteger8 priority2;		//## attribute priority2 
    
    /**
    If this parameter is configurable the default value shall be FALSE. 
    */
    protected static _Boolean slaveOnly;		//## attribute slaveOnly 
    
    /**
    The default initialization value shall be 1.0 seconds.
    */
    protected TimeInterval t;		//## attribute t 
    
    
    // Constructors
    
    //## operation DelayRequestResponseDefaultPTPPprofile() 
    public  DelayRequestResponseDefaultPTPPprofile() {
        //#[ operation DelayRequestResponseDefaultPTPPprofile() 
        //#]
    }
    
    /**
    The default initialization value shall be 3. The configurable range shall be in the range 2 to 10.
    */
    //## auto_generated 
    public static PTPTimeouts getAnnounceReceiptTimeout() {
        return announceReceiptTimeout;
    }
    
    //## auto_generated 
    public static void setAnnounceReceiptTimeout(PTPTimeouts p_announceReceiptTimeout) {
        announceReceiptTimeout = p_announceReceiptTimeout;
    }
    
    /**
    The default initialization value shall be 0.
    */
    //## auto_generated 
    public static Domain getDomain() {
        return domain;
    }
    
    //## auto_generated 
    public static void setDomain(Domain p_domain) {
        domain = p_domain;
    }
    
    //## auto_generated 
    public Integer32 getFrequencyAccuracy() {
        return frequencyAccuracy;
    }
    
    //## auto_generated 
    public void setFrequencyAccuracy(Integer32 p_frequencyAccuracy) {
        frequencyAccuracy = p_frequencyAccuracy;
    }
    
    //## auto_generated 
    public Integer32 getFrequencyAdjustmentRange() {
        return frequencyAdjustmentRange;
    }
    
    //## auto_generated 
    public void setFrequencyAdjustmentRange(Integer32 p_frequencyAdjustmentRange) {
        frequencyAdjustmentRange = p_frequencyAdjustmentRange;
    }
    
    /**
    The default initialization value shall be 1. The configurable range shall be 0 to 4
    */
    //## auto_generated 
    public static TimeInterval getLogAnnounceInterval() {
        return logAnnounceInterval;
    }
    
    //## auto_generated 
    public static void setLogAnnounceInterval(TimeInterval p_logAnnounceInterval) {
        logAnnounceInterval = p_logAnnounceInterval;
    }
    
    /**
    The default initialization value shall be 0. The configurable range shall be 0 to 5.
    */
    //## auto_generated 
    public static TimeInterval getLogMinPdelayReqInterval() {
        return logMinPdelayReqInterval;
    }
    
    //## auto_generated 
    public static void setLogMinPdelayReqInterval(TimeInterval p_logMinPdelayReqInterval) {
        logMinPdelayReqInterval = p_logMinPdelayReqInterval;
    }
    
    /**
    The default initialization value shall be 0. The configurable range shall be -1 to +1
    */
    //## auto_generated 
    public static TimeInterval getLogSyncInterval() {
        return logSyncInterval;
    }
    
    //## auto_generated 
    public static void setLogSyncInterval(TimeInterval p_logSyncInterval) {
        logSyncInterval = p_logSyncInterval;
    }
    
    /**
    The delay request-response mechanism shall be the default path delay measurement mechanism. The peer delay mechanism may also be implemented. 
    
    The best master clock algorithm shall be the algorithm specified by  9.3.2.
    
    Boundary clocks should be used between links that use different path delay mechanisms.
    
    */
    //## auto_generated 
    public DelayMechanism getPathDelayMeasurementMechanism() {
        return pathDelayMeasurementMechanism;
    }
    
    //## auto_generated 
    public void setPathDelayMeasurementMechanism(DelayMechanism p_pathDelayMeasurementMechanism) {
        pathDelayMeasurementMechanism = p_pathDelayMeasurementMechanism;
    }
    
    /**
    The default initialization value shall be 0. 
    */
    //## auto_generated 
    public static Domain getPrimaryDomain() {
        return primaryDomain;
    }
    
    //## auto_generated 
    public static void setPrimaryDomain(Domain p_primaryDomain) {
        primaryDomain = p_primaryDomain;
    }
    
    /**
    default initialization value shall be 128.
    */
    //## auto_generated 
    public static UInteger8 getPriority1() {
        return priority1;
    }
    
    //## auto_generated 
    public static void setPriority1(UInteger8 p_priority1) {
        priority1 = p_priority1;
    }
    
    /**
    The default initialization value shall be 128. 
    */
    //## auto_generated 
    public static UInteger8 getPriority2() {
        return priority2;
    }
    
    //## auto_generated 
    public static void setPriority2(UInteger8 p_priority2) {
        priority2 = p_priority2;
    }
    
    /**
    If this parameter is configurable the default value shall be FALSE. 
    */
    //## auto_generated 
    public static _Boolean getSlaveOnly() {
        return slaveOnly;
    }
    
    //## auto_generated 
    public static void setSlaveOnly(_Boolean p_slaveOnly) {
        slaveOnly = p_slaveOnly;
    }
    
    /**
    The default initialization value shall be 1.0 seconds.
    */
    //## auto_generated 
    public TimeInterval getT() {
        return t;
    }
    
    //## auto_generated 
    public void setT(TimeInterval p_t) {
        t = p_t;
    }
    
}
/*********************************************************************
	File Path	: DelayReqRespSlave/SlaveClock/PTPProfiles/DelayRequestResponseDefaultPTPPprofile.java
*********************************************************************/

