/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: ObjectModel
	Configuration 	: ObjectModel
	Model Element	: PTPVariance
//!	Generated Date	: Fri, 1, Aug 2008 
	File Path	: ObjectModel/ObjectModel/PTPEntities/PTPVariance.java
*********************************************************************/

package PTPEntities;

//## auto_generated
import java.util.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## attribute estimateVariance 
import PTPPrimitivityDataTypes.UInteger16;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;

//----------------------------------------------------------------------------
// PTPEntities/PTPVariance.java                                                                  
//----------------------------------------------------------------------------

//## package PTPEntities 


/**
1.1.1.1	Variance representation
PTP variances shall be represented as follows:
a)	An estimate of the variance, , specified in  7.6.3.2 is computed in units of seconds squared.
b)	The logarithm to the base 2 of this estimate is computed. The computation of the logarithm need not be more precise than the precision of the estimate of the variance.
c)	The logarithm is multiplied by 28 to produce a scaled value.
d)	This scaled value is modified per the hysteresis specification of this subclause to produce the reported value.
e)	The reported value is represented as a 2s complement Integer16. The value 800016 is added to the reported value represented in this form and any overflow is ignored. The result, i.e., the offset scaled reported value, is cast as a UInteger16.
f)	This offset scaled reported value, represented as UInteger16, shall be the value of the log variances specified in  7.6.3.1.
*/
//## class PTPVariance 
public class PTPVariance {
    
    protected UInteger16 estimateVariance;		//## attribute estimateVariance 
    
    protected UInteger16 logarithm;		//## attribute logarithm 
    
    protected UInteger16 logarithmToBase;		//## attribute logarithmToBase 
    
    protected UInteger16 offsetScaledReportedValue;		//## attribute offsetScaledReportedValue 
    
    protected UInteger16 reportedValue;		//## attribute reportedValue 
    
    protected UInteger16 scaledValue;		//## attribute scaledValue 
    
    
    // Constructors
    
    //## operation PTPVariance() 
    public  PTPVariance() {
        //#[ operation PTPVariance() 
        //#]
    }
    
    //## auto_generated 
    public UInteger16 getEstimateVariance() {
        return estimateVariance;
    }
    
    //## auto_generated 
    public void setEstimateVariance(UInteger16 p_estimateVariance) {
        estimateVariance = p_estimateVariance;
    }
    
    //## auto_generated 
    public UInteger16 getLogarithm() {
        return logarithm;
    }
    
    //## auto_generated 
    public void setLogarithm(UInteger16 p_logarithm) {
        logarithm = p_logarithm;
    }
    
    //## auto_generated 
    public UInteger16 getLogarithmToBase() {
        return logarithmToBase;
    }
    
    //## auto_generated 
    public void setLogarithmToBase(UInteger16 p_logarithmToBase) {
        logarithmToBase = p_logarithmToBase;
    }
    
    //## auto_generated 
    public UInteger16 getOffsetScaledReportedValue() {
        return offsetScaledReportedValue;
    }
    
    //## auto_generated 
    public void setOffsetScaledReportedValue(UInteger16 p_offsetScaledReportedValue) {
        offsetScaledReportedValue = p_offsetScaledReportedValue;
    }
    
    //## auto_generated 
    public UInteger16 getReportedValue() {
        return reportedValue;
    }
    
    //## auto_generated 
    public void setReportedValue(UInteger16 p_reportedValue) {
        reportedValue = p_reportedValue;
    }
    
    //## auto_generated 
    public UInteger16 getScaledValue() {
        return scaledValue;
    }
    
    //## auto_generated 
    public void setScaledValue(UInteger16 p_scaledValue) {
        scaledValue = p_scaledValue;
    }
    
}
/*********************************************************************
	File Path	: ObjectModel/ObjectModel/PTPEntities/PTPVariance.java
*********************************************************************/

