/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: ObjectModel
	Configuration 	: ObjectModel
	Model Element	: Sync
//!	Generated Date	: Fri, 1, Aug 2008 
	File Path	: ObjectModel/ObjectModel/PTPMessages/Sync.java
*********************************************************************/

package PTPMessages;

//## auto_generated
import java.util.*;
//## auto_generated
import PTPEnumTypes.*;
//## auto_generated
import PTPDerivedDataTypes.*;
//## auto_generated
import PTPPrimitivityDataTypes.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## operation Sync(MessageHeader,Timestamp) 
import PTPDerivedDataTypes.Timestamp;
//## attribute syncMsg 
import PTPDerivedDataTypes.OctetArray;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## auto_generated
import PTPPrimitivityDataTypes.UInteger16;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;

//----------------------------------------------------------------------------
// PTPMessages/Sync.java                                                                  
//----------------------------------------------------------------------------

//## package PTPMessages 


/**
Table 25: Announce message fields

Bits	Octets 	Offset 	
7	6	5	4	3	2	1	0			
header ( 13.3)	34	0	
originTimestamp	10	34	
currentUtcOffset	2	44	
reserved	1	46	
grandmasterPriority1	1	47	
grandmasterClockQuality 	4	48	
grandmasterPriority2	1	52	
grandmasterIdentity 	8	53	
stepsRemoved 	2	61	
timeSource  	1	63	
*/
//## class Sync 
public class Sync extends EventMessage {
    
    protected static byte sizeOfMsg = 44;		//## attribute sizeOfMsg 
    
    protected OctetArray syncMsg;		//## attribute syncMsg 
    
    protected OctetArray syncMsgOctetArray;		//## attribute syncMsgOctetArray 
    
    
    // Constructors
    
    //## operation Sync() 
    public  Sync() {
        //#[ operation Sync() 
        //#]
    }
    //## operation Sync(MessageHeader,Timestamp) 
    public  Sync(MessageHeader messageHeader, final Timestamp originTimestamp) {
        //#[ operation Sync(MessageHeader,Timestamp) 
        
        
        // System.out.println("In the constructor of Sync.");
        this.messageHeader = messageHeader; 
         
        this.originTimestamp = originTimestamp;
        //System.out.println("End the constructor of Sync.");
        //#]
    }
    //## operation Sync(OctetArray) 
    public  Sync(final OctetArray syncMsgOctetArray) {
        //#[ operation Sync(OctetArray) 
        this.syncMsgOctetArray = syncMsgOctetArray;
        // 34+30=64
        
        //this.syncMsg=new OctetArray((short)64);   
        
        this.syncMsgOctetArray = syncMsgOctetArray;// octetArray(644)  
        
        this.messageHeader = new MessageHeader();
              
        //this.messageHeader.octets[0]= (byte)((byte)(this.transportSpecific.nibbleVal<<4)|this.messageType.messageType)  ; 
        //messageType 
        byte messageTypeByte =(byte)(0x0FL&this.syncMsgOctetArray.octets[0]);  
        
        MessageType messageType=  new MessageType((byte)messageTypeByte) ;
        this.messageHeader.setMessageType(messageType);                                      //
               
        // transport Specific       
        byte transportSpecificByte=(byte)((byte)(0xFL)&(this.syncMsgOctetArray.octets[0]>>4)); 
        Nibble transportSpecific =new Nibble((byte)transportSpecificByte);
        this.messageHeader.setTransportSpecific(transportSpecific);
        
                    
        
        // reserved1              
        //this.messageHeader.octets[1]=(byte)((byte)(this.reserved1.nibbleVal<<4)|this.versionPTP.uinteger4Val)  ;  
        byte versionPTPByte= (byte)(0x0FL&this.syncMsgOctetArray.octets[1]);  
        UInteger4  versionPTP= new UInteger4((byte)versionPTPByte);
        this.messageHeader.setVersionPTP(versionPTP );
        
        // versionPTP 
        byte reserved1Byte=(byte)(0x0FL&this.syncMsgOctetArray.octets[1]>>4);  
        Nibble  reserved1= new Nibble((byte)reserved1Byte);
        this.messageHeader.setReserved1(reserved1);
        
        
        
        // messageLength
        short messageLengthByte1 = (short) ((0x00FFL)&this.syncMsgOctetArray.octets[2]);
        short messageLengthByte2 = (short) ((0xFF00L)&(this.syncMsgOctetArray.octets[3]<<8));   
        short messageLengthBytes= (short)(messageLengthByte1|messageLengthByte2);   
        PTPPrimitivityDataTypes.UInteger16  messageLength=  new PTPPrimitivityDataTypes.UInteger16((short)messageLengthBytes);
        this.messageHeader.setMessageLength(messageLength); 
         
        //domainNumber 
        byte domainNumberBye = (byte)((0x0FL)&this.syncMsgOctetArray.octets[4]);   
         //   public void setDomainNumber(Domain p_domainNumber) {
        PTPEntities.Domain domainNumber = new PTPEntities.Domain((byte)domainNumberBye);
        this.messageHeader.setDomainNumber(domainNumber); 
        
         // reserved2
        UInteger8 reserved2= new UInteger8((byte)this.syncMsgOctetArray.octets[5]) ;
        this.messageHeader.setReserved2(reserved2);
                            
         //flags                    
        
        byte flagFieldByteArray1= this.syncMsgOctetArray.octets[6];
        byte flagFieldByteArray2= this.syncMsgOctetArray.octets[7];
        byte[] flagFieldByteArray = {flagFieldByteArray1, flagFieldByteArray2};
        OctetArray flagFieldOctetArray =    new OctetArray(flagFieldByteArray);   
        this.messageHeader.setFlagField(flagFieldOctetArray); 
        
        
        // correctionField
        long filedByte0 = (0x00000000000000FFL&this.syncMsgOctetArray.octets[8]);
        long filedByte1 = (0x000000000000FF00L&(this.syncMsgOctetArray.octets[9]<<8));    
        long filedByte2 = (0x0000000000FF0000L&(this.syncMsgOctetArray.octets[10]<<16)); 
        long filedByte3 = (0x00000000FF000000L&(this.syncMsgOctetArray.octets[11]<<24)); 
        long filedByte4 = (0x000000FF00000000L&(this.syncMsgOctetArray.octets[12]<<32)); 
        long filedByte5 = (0x0000FF0000000000L&(this.syncMsgOctetArray.octets[13]<<40)); 
        long filedByte6 = (0x00FF000000000000L&(this.syncMsgOctetArray.octets[14]<<48)); 
        long filedByte7 = (0xFF00000000000000L&(this.syncMsgOctetArray.octets[15]<<56));   
        long correctionFieldBytes=(long)(filedByte0|filedByte1|filedByte2|filedByte3|filedByte4|filedByte5|filedByte6|filedByte7) ;
        Integer64 correctionField = new Integer64((long)correctionFieldBytes);
        this.messageHeader.setCorrectionField(correctionField); 
                           
                                
        //reserved3                        
        
        int reserved3Byte0=  (int)(0x000000FFL& this.syncMsgOctetArray.octets[16]);
        int reserved3Byte1=  (int)(0x0000FF00L& this.syncMsgOctetArray.octets[17]<<8);
        int reserved3Byte2=  (int)(0x00FF0000L& this.syncMsgOctetArray.octets[18]<<16);
        int reserved3Byte3=  (int)(0xFF000000L& this.syncMsgOctetArray.octets[19]<<24);  
        int reserved3Bytes=  (int)(reserved3Byte0|reserved3Byte1|reserved3Byte2|reserved3Byte3)   ;  
        UInteger32 reserved3   = new UInteger32((int)reserved3Bytes);
        this.messageHeader.setReserved3(reserved3); 
        
        
        //sourcePortIdentity   (20-29)    
        //clockIdentity Octet[8]
         
        
        byte clockIdentityByteArray0=this.syncMsgOctetArray.octets[20];
        byte clockIdentityByteArray1=this.syncMsgOctetArray.octets[21];
        byte clockIdentityByteArray2=this.syncMsgOctetArray.octets[22];
        byte clockIdentityByteArray3=this.syncMsgOctetArray.octets[23];
        byte clockIdentityByteArray4=this.syncMsgOctetArray.octets[24];
        byte clockIdentityByteArray5=this.syncMsgOctetArray.octets[25];
        byte clockIdentityByteArray6=this.syncMsgOctetArray.octets[26];
        byte clockIdentityByteArray7=this.syncMsgOctetArray.octets[27]; 
        
        byte[]  clockIdentityByteArray = {clockIdentityByteArray0, clockIdentityByteArray1, clockIdentityByteArray2,clockIdentityByteArray3, clockIdentityByteArray4, clockIdentityByteArray5, clockIdentityByteArray6, clockIdentityByteArray7  };
        OctetArray clockIdentityOctetArray = new OctetArray(clockIdentityByteArray); 
        
        ClockIdentity clockIdentity =new ClockIdentity(clockIdentityOctetArray);
         
        //portNumber    
        
        short portNumber1 = (short) ((0x00FFL)&this.syncMsgOctetArray.octets[28]);
        short portNumber2 = (short) ((0xFF00L)&(this.syncMsgOctetArray.octets[29]<<8));  
        short portNo= (short)(portNumber2|portNumber1);   
        UInteger16 portNumber = new UInteger16((short)portNo);  
        
        PortIdentity portIdentity = new PortIdentity(clockIdentity,portNumber);
        this.messageHeader.setSourcePortIdentity(portIdentity); 
                               
                                
        // sequenceId     (30-31)
        
        short sequencIdByte1= (short) ((0x00FFL)&this.syncMsgOctetArray.octets[30]);
        short sequencIdByte2= (short)((0xFF00L)&(this.syncMsgOctetArray.octets[31]<<8));
        short sequenceIdBytes=(short)(sequencIdByte1|sequencIdByte2); 
        
        UInteger16  sequenceId = new UInteger16((short)sequenceIdBytes);
        this.messageHeader.setSequenceId(sequenceId); 
                                          
        
        //controlField
        //this.messageHeader.octets[32]=(byte)this.controlField.uinteger8Val  ;    
        byte controlFieldByte=(byte)this.syncMsgOctetArray.octets[32] ; 
        UInteger8 controlField= new UInteger8((byte)controlFieldByte);
        this.messageHeader.setControlField(controlField); 
        
        //logMessageInterval
        //this.messageHeader.octets[33]=(byte)this.logMessageInterval.integer8Val  ;   
        byte logMessageIntervalByte = (byte)this.syncMsgOctetArray.octets[33] ;
        Integer8 logMessageInterval = new Integer8(logMessageIntervalByte); 
        this.messageHeader.setLogMessageInterval(logMessageInterval); 
        
        
        
        
           // body
        //this.syncMsg=new OctetArray((short)10);    
        
        
        long nanosecondFieldByte0 = (long)(0x00000000000000FFL)& this.syncMsgOctetArray.octets[34];
        long nanosecondFieldByte1 = (long)(0x000000000000FF00L)& (this.syncMsgOctetArray.octets[35]<<8);
        long nanosecondFieldByte2 = (long)(0x0000000000FF0000L)& (this.syncMsgOctetArray.octets[36]<<16);
        long nanosecondFieldByte3 = (long)(0x00000000FF000000L)& (this.syncMsgOctetArray.octets[37]<<24);  
        
        long nanosecondFieldBytes = (long)(nanosecondFieldByte3|nanosecondFieldByte2|nanosecondFieldByte1|nanosecondFieldByte0) ;
        UInteger32 nanosecondField = new UInteger32(nanosecondFieldBytes);
        //secondsField   (UInteger48)
        
        long secondsFieldByte0= (long)(0x00000000000000FFL)& this.syncMsgOctetArray.octets[38];
        long secondsFieldByte1= (long)(0x000000000000FF00L)& (this.syncMsgOctetArray.octets[39]<<8);
        long secondsFieldByte2= (long)(0x0000000000FF0000L)& (this.syncMsgOctetArray.octets[40]<<16);
        long secondsFieldByte3= (long)(0x00000000FF000000L)& (this.syncMsgOctetArray.octets[41]<<24);
        long secondsFieldByte4= (long)(0x000000FF00000000L)& (this.syncMsgOctetArray.octets[42]<<32);
        long secondsFieldByte5= (long)(0x0000FF0000000000L)& (this.syncMsgOctetArray.octets[43]<<40);  
        
        long secondsFieldBytes = (long)(secondsFieldByte5|secondsFieldByte4|secondsFieldByte3|secondsFieldByte2|secondsFieldByte1|secondsFieldByte0) ;
        UInteger48 secondsField = new UInteger48(secondsFieldBytes); 
        
        Timestamp timeStamp= new Timestamp(secondsField,nanosecondField);
            
           
        this.setOriginTimestamp(timeStamp);
                                                                                                   
          
        
        //#]
    }
    
    //## operation GetSyncMsgOctetArray() 
    public OctetArray GetSyncMsgOctetArray() {
        //#[ operation GetSyncMsgOctetArray() 
        // 34+10=44
        
        //this.syncMsgOctetArray=new OctetArray((short)44); 
        //System.out.println("\nEnter getSyncOctetArray()");
        
        byte[] syncMsgByteArray ={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
        //this.messageHeader = this.getMessageHeader();   
          
        if(this.getMessageHeader()!=null)
        {
        //transportSpecific, messageType  
        byte byte0a = (byte)(this.getMessageHeader().getTransportSpecific().getNibbleVal()<<4);   
        byte byte0b = (byte) this.getMessageHeader().getMessageType().GetMessageType()  ;   
        byte byte0= (byte) (byte0a|byte0b);   
        syncMsgByteArray[0]=byte0;   
        
        //System.out.println("byte 0:="+byte0);
                               
        // reserved1, versionPTP  
        byte byte1a = (byte) (this.getMessageHeader().getReserved1().getNibbleVal()<<4);
        byte byte1b = this.messageHeader.getVersionPTP().getUinteger4Val()  ;
        byte byte1 = (byte) (byte1a|byte1b);  
        syncMsgByteArray[1]=byte1;
        //System.out.println("byte 1:="+byte1);
        
        
        // messageLength
        byte byte2=(byte)(0x00FF & this.getMessageHeader().getMessageLength().getUinteger16Val() ) ;
        syncMsgByteArray[2]=byte2;
        //System.out.println("byte 2:="+byte2);
         
        byte byte3=(byte)(0x00FF&(this.getMessageHeader().getMessageLength().getUinteger16Val()>>8 ))  ;
        syncMsgByteArray[3]=byte3;
        //System.out.println("byte 3:="+byte3);
        
        //domainNumber 
        byte byte4= (byte) this.getMessageHeader().getDomainNumber().getDomain();   
        syncMsgByteArray[4]=byte4;
        //System.out.println("byte 4:="+byte4);
        
         // reserved2
        byte byte5= (byte)this.getMessageHeader().getReserved2().getUinteger8Val();   
        syncMsgByteArray[5]=byte5;
        //System.out.println("byte 5:="+byte5);
        
         //flags                    
        byte byte6= (byte)this.getMessageHeader().getFlagField().getOctets(0);   
        syncMsgByteArray[6]=byte6;  
        //System.out.println("byte 6:="+byte6);
          
        byte byte7= (byte)this.getMessageHeader().getFlagField().getOctets(1);   
        syncMsgByteArray[7]=byte7;
        //System.out.println("byte 7:="+byte7);
        
        
        // correctionField
        byte byte8= (byte)(this.getMessageHeader().getCorrectionField().getInteger64Val()&0x00000000000000FF);   
        syncMsgByteArray[8]=byte8;
        //System.out.println("\nbyte 8:="+byte8);
        
        byte byte9= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>8)&0x00000000000000FF);   
        syncMsgByteArray[9]=byte9;
        //System.out.println("byte 9:="+byte9);
        
        byte byte10= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>16)&0x00000000000000FF);     
        syncMsgByteArray[10]=byte10;
        //System.out.println("byte 10:="+byte10);
        
        byte byte11= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>24)&0x00000000000000FF);      
        syncMsgByteArray[11]=byte11;
        //System.out.println("byte 11:="+byte11);
        
        byte byte12= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>32)&0x00000000000000FF);     
        syncMsgByteArray[12]=byte12;
        //System.out.println("byte 12:="+byte12);
        
        byte byte13= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>40)&0x00000000000000FF);     
        syncMsgByteArray[13]=byte13;
        //System.out.println("byte 13:="+byte13);
        
        byte byte14= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>48)&0x00000000000000FF);     
        syncMsgByteArray[14]=byte14;
        //System.out.println("byte 14:="+byte14);
        
        byte byte15= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>> 56)&0x00000000000000FF);      
        syncMsgByteArray[15]=byte15;
        //System.out.println("byte 15:="+byte15);
                                
                                
        //reserved3                        
        byte byte16= (byte)(this.getMessageHeader().getReserved3().getUinteger32Val()&0x000000FF);   
        syncMsgByteArray[16]=byte16;
        //System.out.println("\nbyte 16:="+byte16);
        
        byte byte17= (byte)((this.getMessageHeader().getReserved3().getUinteger32Val()>>8)&0x000000FF) ; 
        syncMsgByteArray[17]=byte17;
        //System.out.println("byte 17:="+byte17);
        
        byte byte18= (byte)((this.getMessageHeader().getReserved3().getUinteger32Val()>>16)&0x000000FF) ;  
        syncMsgByteArray[18]=byte18;
        //System.out.println("byte 18:="+byte18);
        
        byte byte19= (byte)((this.getMessageHeader().getReserved3().getUinteger32Val()>>24)&0x000000FF) ;  
        syncMsgByteArray[19]=byte19;
        //System.out.println("byte 19:="+byte19);
        
        
        
        //sourcePortIdentity   (20-29)    
        //clockIdentity Octet[8]
        byte byte20= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(0);  
        syncMsgByteArray[20]=byte20;
        //System.out.println("\nbyte 20:="+byte20);
        
        byte byte21= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(1);   
        syncMsgByteArray[21]=byte21;
        //System.out.println("byte 21:="+byte21);
        
        byte byte22= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(2);   
        syncMsgByteArray[22]=byte22;
        //System.out.println("byte 22:="+byte22);
        
        byte byte23= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(3);   
        syncMsgByteArray[23]=byte23;
        //System.out.println("byte 23:="+byte23);
        
        byte byte24= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(4);   
        syncMsgByteArray[24]=byte24;
        //System.out.println("byte 24:="+byte24);
        
        byte byte25= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(5);    
        syncMsgByteArray[25]=byte25;
        //System.out.println("byte 25:="+byte25);
        
        byte byte26= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(6);    
        syncMsgByteArray[26]=byte26;
        //System.out.println("byte 26:="+byte26);
        
        byte byte27= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(7);    
        syncMsgByteArray[27]=byte27;
        //System.out.println("byte 27:="+byte27);
        
        
        //portNumber    
        byte byte28= (byte)(this.getMessageHeader().getSourcePortIdentity().getPortNumber().getUinteger16Val()&0x00FF)  ;  
        syncMsgByteArray[28]=byte28;
        //System.out.println("\nbyte 28:="+byte28);
        
        byte byte29= (byte)((this.getMessageHeader().getSourcePortIdentity().getPortNumber().getUinteger16Val()>>8)&0x00FF);    
        syncMsgByteArray[29]=byte29;
        //System.out.println("byte 29:="+byte29);
        
        // sequenceId     (30-31)
        byte byte30= (byte)(this.getMessageHeader().getSequenceId().getUinteger16Val()&0x00FF)  ;    
        syncMsgByteArray[30]=byte30;
        //System.out.println("\nbyte 30:="+byte30);
        
        byte byte31= (byte)((this.getMessageHeader().getSequenceId().getUinteger16Val()>>8)&0x00FF) ;    
        syncMsgByteArray[31]=byte31;
        //System.out.println("byte 31:="+byte31);
        
        //controlField
        byte byte32= (byte)this.getMessageHeader().getControlField().getUinteger8Val() ;    
        syncMsgByteArray[32]=byte32;
        //System.out.println("byte 32:="+byte32);
        
        //logMessageInterval
        byte byte33= (byte)this.getMessageHeader().getLogMessageInterval().getInteger8Val() ;    
        syncMsgByteArray[33]=byte33;    
        //System.out.println("byte 33:="+byte33);
        
        }  
        else
        System.out.println("Msg header is null!!!");
        
        
           // body
        //this.syncMsg=new OctetArray((short)10);    
        byte byte34 = (byte)(this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()&0x000000FF);
        byte byte35 = (byte)((this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()>>8)&0x000000FF) ;
        byte byte36 = (byte)((this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()>>16)&0x000000FF);                                                                                                    
        byte byte37 = (byte)((this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()>>24)&0x000000FF);  
                                                                                                          
        syncMsgByteArray[34]=byte34;    
        //System.out.println("\nbyte 34:="+byte34);
        
        syncMsgByteArray[35]=byte35;    
        //System.out.println("byte 35:="+byte35);
        
        syncMsgByteArray[36]=byte36;      
        //System.out.println("byte 36:="+byte36);
        
        syncMsgByteArray[37]=byte37;
        //System.out.println("byte 37:="+byte37);
        
        
        //secondsField   (UInteger48)
        
        byte byte38 = (byte)(this.getOriginTimestamp().getSecondsField().getUinteger48Val()& 0x00000000000000FF);
        byte byte39 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>8)& 0x0000000000000FF) ;
        byte byte40 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>16)& 0x0000000000000FF) ;
        byte byte41 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>24)&0x00000000000000FF) ;
        byte byte42 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>32)&0x00000000000000FF) ;
        byte byte43 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>40)&0x00000000000000FF) ;
        
        syncMsgByteArray[38]=byte38;   
        //System.out.println("\nbyte 38:="+byte38);
        
        syncMsgByteArray[39]=byte39; 
        //System.out.println("byte 39:="+byte39);
        
        syncMsgByteArray[40]=byte40; 
        //System.out.println("byte 40:="+byte40);
        
        syncMsgByteArray[41]=byte41; 
        //System.out.println("byte 41:="+byte41);   
        
        syncMsgByteArray[42]=byte42;  
        //System.out.println("byte 42:="+byte42);
        
        syncMsgByteArray[43]=byte43;
        //System.out.println("byte 43:="+byte43);
        
        this.syncMsgOctetArray=new OctetArray(syncMsgByteArray);   
        
        //System.out.println("End getSyncOctetArray()\n");   
        return this.syncMsgOctetArray;
        
        //#]
    }
    
    //## operation GetTimestamp() 
    public Timestamp GetTimestamp() {
        //#[ operation GetTimestamp() 
        return this.originTimestamp;
        //#]
    }
    
    //## operation PrintSync() 
    public void PrintSync() {
        //#[ operation PrintSync() 
        System.out.println("\nEnter Print Sync Message.");
        System.out.println("transportSpecific:="+this.getMessageHeader().getTransportSpecific().getNibbleVal());
        System.out.println("messageType:="+this.getMessageHeader().getMessageType().getMessageType());
        //System.out.println("reserved1:="+reserved1);
        System.out.println("versionPTP:="+this.getMessageHeader().getVersionPTP().getUinteger4Val());
        System.out.println("messageLength:="+this.getMessageHeader().getMessageLength().getUinteger16Val());
        System.out.println("domainNumber:="+this.getMessageHeader().getDomainNumber().getDomain());
        //System.out.println("reserved2:="+reserved2);
        System.out.println("flagField[0]:="+this.getMessageHeader().getFlagField().getOctets(0));  
        System.out.println("flagField[1]:="+this.getMessageHeader().getFlagField().getOctets(1));  
        
        System.out.println("correctionField:="+this.getMessageHeader().getCorrectionField().getInteger64Val());
        
        //System.out.println("reserved3:="+reserved3);
        System.out.println("sourcePortIdentity[0]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(0)); 
        System.out.println("sourcePortIdentity[1]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(1)); 
        System.out.println("sourcePortIdentity[2]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(2)); 
        System.out.println("sourcePortIdentity[3]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(3)); 
        System.out.println("sourcePortIdentity[4]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(4)); 
        System.out.println("sourcePortIdentity[5]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(5)); 
        System.out.println("sourcePortIdentity[6]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(6)); 
        System.out.println("sourcePortIdentity[7]:="+this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(7)); 
        
        System.out.println("sourcePortIdentity:="+this.getMessageHeader().getSourcePortIdentity().getPortNumber().getUinteger16Val()); 
        
        System.out.println("sequenceId:="+this.getMessageHeader().getSequenceId().getUinteger16Val());
        System.out.println("controlField:="+this.getMessageHeader().getControlField().getUinteger8Val());
        System.out.println("logMessageInterval:="+this.getMessageHeader().getLogMessageInterval().getInteger8Val());
         
         //========
        System.out.println("originTimestamp(nanos):="+this.getOriginTimestamp().getNanosecondsField().getUinteger32Val());
        System.out.println("originTimestamp(sec):="+this.getOriginTimestamp().getSecondsField().getUinteger48Val());  
        
        System.out.println(" End Print Sync Message.\n");
        //#]
    }
    
    //## operation SetSyncMsgItems(OctetArray) 
    public void SetSyncMsgItems(final OctetArray syncMsgOctetArray) {
        //#[ operation SetSyncMsgItems(OctetArray) 
        // 34+30=64
        
        //this.syncMsg=new OctetArray((short)64);   
        
        this.syncMsgOctetArray = syncMsgOctetArray;// octetArray(644)  
        
        this.messageHeader = new MessageHeader();
              
        //this.messageHeader.octets[0]= (byte)((byte)(this.transportSpecific.nibbleVal<<4)|this.messageType.messageType)  ; 
        //messageType 
        byte messageTypeByte =(byte)(0x0FL&this.syncMsgOctetArray.octets[0]);  
        
        MessageType messageType=  new MessageType((byte)messageTypeByte) ;
        this.messageHeader.setMessageType(messageType);                                      //
               
        // transport Specific       
        byte transportSpecificByte=(byte)((byte)(0xFL)&(this.syncMsgOctetArray.octets[0]>>4)); 
        Nibble transportSpecific =new Nibble((byte)transportSpecificByte);
        this.messageHeader.setTransportSpecific(transportSpecific);
        
                    
        
        // reserved1              
        //this.messageHeader.octets[1]=(byte)((byte)(this.reserved1.nibbleVal<<4)|this.versionPTP.uinteger4Val)  ;  
        byte versionPTPByte= (byte)(0x0FL&this.syncMsgOctetArray.octets[1]);  
        UInteger4  versionPTP= new UInteger4((byte)versionPTPByte);
        this.messageHeader.setVersionPTP(versionPTP );
        
        // versionPTP 
        byte reserved1Byte=(byte)(0x0FL&this.syncMsgOctetArray.octets[1]>>4);  
        Nibble  reserved1= new Nibble((byte)reserved1Byte);
        this.messageHeader.setReserved1(reserved1);
        
        
        
        // messageLength
        short messageLengthByte1 = (short) ((0x00FFL)&this.syncMsgOctetArray.octets[2]);
        short messageLengthByte2 = (short) ((0xFF00L)&(this.syncMsgOctetArray.octets[3]<<8));   
        short messageLengthBytes= (short)(messageLengthByte1|messageLengthByte2);   
        PTPPrimitivityDataTypes.UInteger16  messageLength=  new PTPPrimitivityDataTypes.UInteger16((short)messageLengthBytes);
        this.messageHeader.setMessageLength(messageLength); 
         
        //domainNumber 
        byte domainNumberBye = (byte)((0x0FL)&this.syncMsgOctetArray.octets[4]);   
         //   public void setDomainNumber(Domain p_domainNumber) {
        PTPEntities.Domain domainNumber = new PTPEntities.Domain((byte)domainNumberBye);
        this.messageHeader.setDomainNumber(domainNumber); 
        
         // reserved2
        UInteger8 reserved2= new UInteger8((byte)this.syncMsgOctetArray.octets[5]) ;
        this.messageHeader.setReserved2(reserved2);
                            
         //flags                    
        byte flagFieldByteArray1= this.syncMsgOctetArray.octets[6];
        byte flagFieldByteArray2= this.syncMsgOctetArray.octets[7];
        byte[] flagFieldByteArray = {flagFieldByteArray1, flagFieldByteArray2};
        OctetArray flagFieldOctetArray =    new OctetArray(flagFieldByteArray);   
        this.messageHeader.setFlagField(flagFieldOctetArray); 
        
        
        
        // correctionField
        long filedByte0 = (0x00000000000000FFL&this.syncMsgOctetArray.octets[8]);
        long filedByte1 = (0x000000000000FF00L&(this.syncMsgOctetArray.octets[9]<<8));    
        long filedByte2 = (0x0000000000FF0000L&(this.syncMsgOctetArray.octets[10]<<16)); 
        long filedByte3 = (0x00000000FF000000L&(this.syncMsgOctetArray.octets[11]<<24)); 
        long filedByte4 = (0x000000FF00000000L&(this.syncMsgOctetArray.octets[12]<<32)); 
        long filedByte5 = (0x0000FF0000000000L&(this.syncMsgOctetArray.octets[13]<<40)); 
        long filedByte6 = (0x00FF000000000000L&(this.syncMsgOctetArray.octets[14]<<48)); 
        long filedByte7 = (0xFF00000000000000L&(this.syncMsgOctetArray.octets[15]<<56));   
        long correctionFieldBytes=(long)(filedByte0|filedByte1|filedByte2|filedByte3|filedByte4|filedByte5|filedByte6|filedByte7) ;
        Integer64 correctionField = new Integer64((long)correctionFieldBytes);
        this.messageHeader.setCorrectionField(correctionField); 
                           
                                
        //reserved3                        
        
        int reserved3Byte0=  (int)(0x000000FFL& this.syncMsgOctetArray.octets[16]);
        int reserved3Byte1=  (int)(0x0000FF00L& this.syncMsgOctetArray.octets[17]<<8);
        int reserved3Byte2=  (int)(0x00FF0000L& this.syncMsgOctetArray.octets[18]<<16);
        int reserved3Byte3=  (int)(0xFF000000L& this.syncMsgOctetArray.octets[19]<<24);  
        int reserved3Bytes=  (int)(reserved3Byte0|reserved3Byte1|reserved3Byte2|reserved3Byte3)   ;  
        UInteger32 reserved3   = new UInteger32((int)reserved3Bytes);
        this.messageHeader.setReserved3(reserved3); 
        
        
        //sourcePortIdentity   (20-29)    
        //clockIdentity Octet[8]
         
        byte clockIdentityByteArray0=this.syncMsgOctetArray.octets[20];
        byte clockIdentityByteArray1=this.syncMsgOctetArray.octets[21];
        byte clockIdentityByteArray2=this.syncMsgOctetArray.octets[22];
        byte clockIdentityByteArray3=this.syncMsgOctetArray.octets[23];
        byte clockIdentityByteArray4=this.syncMsgOctetArray.octets[24];
        byte clockIdentityByteArray5=this.syncMsgOctetArray.octets[25];
        byte clockIdentityByteArray6=this.syncMsgOctetArray.octets[26];
        byte clockIdentityByteArray7=this.syncMsgOctetArray.octets[27]; 
        
        byte[]  clockIdentityByteArray = {clockIdentityByteArray0, clockIdentityByteArray1, clockIdentityByteArray2,clockIdentityByteArray3, clockIdentityByteArray4, clockIdentityByteArray5, clockIdentityByteArray6, clockIdentityByteArray7  };
        OctetArray clockIdentityOctetArray = new OctetArray(clockIdentityByteArray); 
        
        ClockIdentity clockIdentity =new ClockIdentity(clockIdentityOctetArray);
         
        //portNumber    
        
        short portNumber1 = (short) ((0x00FFL)&this.syncMsgOctetArray.octets[28]);
        short portNumber2 = (short) ((0xFF00L)&(this.syncMsgOctetArray.octets[29]<<8));  
        short portNo= (short)(portNumber2|portNumber1);   
        UInteger16 portNumber = new UInteger16((short)portNo);  
        
        PortIdentity portIdentity = new PortIdentity(clockIdentity,portNumber);
        this.messageHeader.setSourcePortIdentity(portIdentity); 
                               
                                
        // sequenceId     (30-31)
        
        short sequencIdByte1= (short) ((0x00FFL)&this.syncMsgOctetArray.octets[30]);
        short sequencIdByte2= (short)((0xFF00L)&(this.syncMsgOctetArray.octets[31]<<8));
        short sequenceIdBytes=(short)(sequencIdByte1|sequencIdByte2); 
        
        UInteger16  sequenceId = new UInteger16((short)sequenceIdBytes);
        this.messageHeader.setSequenceId(sequenceId); 
                                          
        
        //controlField
        byte controlFieldByte=(byte)this.syncMsgOctetArray.octets[32] ; 
        UInteger8 controlField= new UInteger8((byte)controlFieldByte);
        this.messageHeader.setControlField(controlField); 
        
        //logMessageInterval
        byte logMessageIntervalByte = (byte)this.syncMsgOctetArray.octets[33] ;
        Integer8 logMessageInterval = new Integer8(logMessageIntervalByte); 
        this.messageHeader.setLogMessageInterval(logMessageInterval); 
        
        
        
        
           // body
        //this.syncMsg=new OctetArray((short)10);    
        
        
        long nanosecondFieldByte0 = (long)(0x00000000000000FFL)& this.syncMsgOctetArray.octets[34];
        long nanosecondFieldByte1 = (long)(0x000000000000FF00L)& (this.syncMsgOctetArray.octets[35]<<8);
        long nanosecondFieldByte2 = (long)(0x0000000000FF0000L)& (this.syncMsgOctetArray.octets[36]<<16);
        long nanosecondFieldByte3 = (long)(0x00000000FF000000L)& (this.syncMsgOctetArray.octets[37]<<24);  
        
        long nanosecondFieldBytes = (long)(nanosecondFieldByte3|nanosecondFieldByte2|nanosecondFieldByte1|nanosecondFieldByte0) ;
        UInteger32 nanosecondField = new UInteger32(nanosecondFieldBytes);
        //secondsField   (UInteger48)
        
        long secondsFieldByte0= (long)(0x00000000000000FFL)&  this.syncMsg.octets[38];
        long secondsFieldByte1= (long)(0x000000000000FF00L)& (this.syncMsg.octets[39]<<8);
        long secondsFieldByte2= (long)(0x0000000000FF0000L)& (this.syncMsg.octets[40]<<16);
        long secondsFieldByte3= (long)(0x00000000FF000000L)& (this.syncMsg.octets[41]<<24);
        long secondsFieldByte4= (long)(0x000000FF00000000L)& (this.syncMsg.octets[42]<<32);
        long secondsFieldByte5= (long)(0x0000FF0000000000L)& (this.syncMsg.octets[43]<<40);  
        
        long secondsFieldBytes = (long)(secondsFieldByte5|secondsFieldByte4|secondsFieldByte3|secondsFieldByte2|secondsFieldByte1|secondsFieldByte0) ;
        UInteger48 secondsField = new UInteger48(secondsFieldBytes); 
        
        Timestamp timeStamp= new Timestamp(secondsField,nanosecondField);
            
           
        this.setOriginTimestamp(timeStamp);
                                                                                                   
          
        
        //#]
    }
    
    //## auto_generated 
    public static byte getSizeOfMsg() {
        return sizeOfMsg;
    }
    
    //## auto_generated 
    public static void setSizeOfMsg(byte p_sizeOfMsg) {
        sizeOfMsg = p_sizeOfMsg;
    }
    
    //## auto_generated 
    public OctetArray getSyncMsg() {
        return syncMsg;
    }
    
    //## auto_generated 
    public void setSyncMsg(OctetArray p_syncMsg) {
        syncMsg = p_syncMsg;
    }
    
    //## auto_generated 
    public OctetArray getSyncMsgOctetArray() {
        return syncMsgOctetArray;
    }
    
    //## auto_generated 
    public void setSyncMsgOctetArray(OctetArray p_syncMsgOctetArray) {
        syncMsgOctetArray = p_syncMsgOctetArray;
    }
    
}
/*********************************************************************
	File Path	: ObjectModel/ObjectModel/PTPMessages/Sync.java
*********************************************************************/

